--================================================================
--[[
GuildBlock(er)
	by Chrome67 (aka. Rhusty@EmeraldDream.US)
	available on Curse.com and WoWInterface.com

-- Change Log --
-- 0.01 initial beta release
-- 0.02 thru 0.06 I musta done some stuff...just don't remember
-- 0.06 TOC Update, added Whisper response msg
]]--
--================================================================

--[[ Initialization ]]--

GName = nil
GuildBlock_DEBUG = 1
local version = "0.06a"
local wholib = LibStub:GetLibrary('LibWho-2.0'):Library()
local players = {}
local update = false
local delay = 65
local counter = 0
local frame = CreateFrame("Frame")

--[[ Slash Commands ]]--

SLASH_GUILDBLOCK1 = "/guildblock"
SLASH_GUILDBLOCK2 = "/gblock"

--[[ Functions ]]--

local function UpdateText(event, results, a2)
	players = results
	if players and GuildBlock_DEBUG == 1 then		--***used for debugging***
		print(players)			
		for k,v in pairs(players) do
			print(k,v.Name)
		end
	end
end

local function updateList()
	if GName then
		if GuildBlock_DEBUG == 1 then print("Updating WHO")	end			--***used for debugging***
		wholib:Who('g-' .. GName, {queue = wholib.WHOLIB_QUERY_QUIET, timeout = 0, callback = UpdateText})
		if GuildBlock_DEBUG == 1 then print("WHO updated!") end		--***used for debugging***
	end
end

local function OnUpdate(self, elapsed)
	counter = counter + elapsed
	if counter >= delay then
		if update then
			updateList()
		end
		counter = 0
	end
end

local function OnEvent(self, event, addon)
	if event == "PLAYER_LOGIN" then
		update = true
		print("Now ignoring the entire |cffffd700<"..GName..">|r guild!")
		print("(|cff66ccff-=GuildBlock=-|r v"..version.." by |cffe62e00Rhusty Tool'z & Toy'z|r)")
		print("(http://www.RhustyToyz.com)")
		frame:UnregisterEvent("PLAYER_LOGIN")
		updateList()
	else
		if event == "ADDON_LOADED" and addon == "GuildBlock"
			then
				if GName == nil then GName = "Bandit Lounge" end
		end
		update = true
	end
end

--[[ Slash Commands and Help ]]--

local function showHelp()
	print("  ")
	print("** GuildBlock(er) Help: **")
	print("(http://www.RhustyToyz.com)")
	print("(Currently blocking <|cffffd700"..GName.."|r>) ")
	print("/gblock      - returns this list")
	print("/gblock help - returns this list")
	print("/gblock <guildname> - sets blocked guild to <guildname>")
	print("NOTE: There is no direct guildname checking for the guild entered, so misspellings will result in no blocking.  Be sure to include all words in the guildname (ie. \"The Nameless Ones\")")
end

SlashCmdList["GUILDBLOCK"] = function (msg)
	local cmd, arg = strmatch(msg, "%s*([^%s]+)%s*(.*)");
	if cmd == nil or strlen(cmd) < 1 or cmd == "help" then
		showHelp()
		return
	end
	if cmd ~= nil and strlen(cmd) > 1 and cmd ~= "DEBUG" then
		GName = msg
		print("GuildBlock: Now blocking <|cffffd700"..GName.."|r>!")
		players = {}
		updateList()
		return
	end
	if cmd ~= nil and strlen(cmd) > 1 and cmd == "DEBUG" then 
		if GuildBlock_DEBUG == 0
			then
				GuildBlock_DEBUG = 1
				print("GuildBlock DEBUGGING ON!  (Currently blocking <|cffffd700"..GName.."|r>) ")
				return
			else
				GuildBlock_DEBUG = 0
				print("GuildBlock DEBUGGING OFF!  (Currently blocking <|cffffd700"..GName.."|r>) ")
				return
		end
	end
end


--[[ Chat Scanning ]]--

local gsub, orig, prevReportTime, prevLineId, result, prevMsg, prevPlayer = gsub, GUILDBLOCKED_MSG, 0, 0, nil, nil, nil
local GB_filter = function(_, event, msg, author, _, _, _, flag, channelId, _, _, _, lineId)
		
	if GuildBlock_DEBUG == 1 then print( "==Test: "..author..", " ..msg.." !!!==") end -- ***For Debugging*** --
	
	for k,v in pairs(players) do
		if v.Name == author then
			if GuildBlock_DEBUG == 1 then DEFAULT_CHAT_FRAME:AddMessage("BLOCKED " ..event..", "..msg.. " from " ..author.. "!!! (-=GuildBlock=- TESTING)") end
			result = true 
			return true
		end 
	end
	if (event == "CHAT_MSG_CHANNEL" and channelId == 0)
		then 
			result = nil 
			return 
	end 
	if event == "CHAT_MSG_WHISPER" 
		then 
			if flag == "GM" 
				then 
					result = nil 
					return 
			end 
			for i=1, select(2, BNGetNumFriends()) do
				local toon = BNGetNumFriendToons(i)
				for j=1, toon do
					local _, rName, rGame = BNGetFriendToonInfo(i, j)
					if (rName == author and rGame == "WoW")
						then
							result = nil 
							return
					end
				end
			end
			local playerName = UnitName("player")
			local responsemsg = "GUILDBLOCK MSG: <|cffffd700"..GName.."|r> is currently being blocked by "..playerName.."."
			SendChatMessage(responsemsg, "WHISPER", nil, author)
	end
	if event == "CHAT_MSG_WHISPER_INFORM"
		then
			if msg == responsemsg
				then
					result = true
					return true
			end
	end		
	local debug = msg 
	if (msg == prevMsg and author == prevPlayer) 
		then 
			result = true 
			return true 
	end
	prevMsg = msg prevPlayer = author
	result = nil
end

--[[Chat Filters]]--

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_EMOTE", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_DND", GB_filter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_AFK", GB_filter)

--[[Register Events]]--

frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("ADDON_LOADED")

--[[Register Scripts]]--

frame:SetScript("OnEvent", OnEvent)
frame:SetScript("OnUpdate", OnUpdate)